//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btStartClick(TObject *Sender)
{
 char cDriveName[20];
 char cBuff[100];
 AnsiString aString;
 HANDLE hDevice;
 DISK_GEOMETRY dg;
 DWORD junk;
 FILE *fout, *fin;
 int blocks, iLastBlock, iCheck, z1, z2;
 DWORD z;
 bool bResult;
 unsigned char bin[10];

    strcpy(cDriveName,cbDrive->Text.c_str());
    strcat(cDriveName,":");
    if(QueryDosDevice(cDriveName,cBuff, 100) == 0)
        MessageBox(NULL,"could not query device","ERROR",MB_OK);
    else
    {
        aString = cBuff;
        strcpy(cDriveName,"\\\\.\\PHYSICALDRIVE");
        strcpy(cBuff, aString.SubString(aString.AnsiPos("Harddisk")+8,1).c_str());
        if( cBuff[0] < '0' || cBuff[0] > '9')
        {
            MessageBox(NULL,"Query did not return expected dive number","ERROR",MB_OK);
            return;
        }
        strcat(cDriveName,cBuff);

	    hDevice = CreateFile(cDriveName,  // drive to open
						    GENERIC_READ,                // no access to the drive
						    FILE_SHARE_READ | FILE_SHARE_WRITE, // share mode
						    NULL,             // default security attributes
						    OPEN_EXISTING,    // disposition
						    0,                // file attributes
						    NULL);            // do not copy file attributes

	    if (hDevice == INVALID_HANDLE_VALUE) // cannot open the drive
	    {
		    MessageBox(NULL,"MMC drive open error","ERROR",MB_OK);
		    return;
	    }

	    if( !DeviceIoControl(hDevice,				// device to be queried
						    IOCTL_DISK_GET_DRIVE_GEOMETRY,  // operation to perform
						    NULL, 0,				// no input buffer
						    &dg, sizeof(dg),     // output buffer
						    &junk,                 // # bytes returned
						    (LPOVERLAPPED) NULL))  // synchronous I/O
	    {
		    MessageBox(NULL,"IOCTL_DISK_GET_DRIVE_GEOMETRY failed","ERROR",MB_OK);
            CloseHandle(hDevice);
		    return;
	    }

	    if(dg.MediaType != RemovableMedia)
        {
            strcpy(cBuff,"your system does not recognize a removable media at >");
            strcat(cBuff,cbDrive->Text.c_str());
		    MessageBox(NULL,cBuff,"ERROR",MB_OK);
            CloseHandle(hDevice);
		    return;
	    }


        if(!SaveDialog1->Execute())
        {
            MessageBox(NULL,"no image file selected","ERROR",MB_OK);
            CloseHandle(hDevice);
            return;
        }

        if((fout=fopen(SaveDialog1->FileName.c_str(),"wb")) == NULL)
        {
            MessageBox(NULL,"image file does not open","ERROR",MB_OK);
            CloseHandle(hDevice);
            return;
        }

        // Eprom auslesen
        char* buff = (unsigned char*)malloc (520);
        blocks = 0;

        while(ReadFile(hDevice, buff, 512, &z, NULL) != 0 && z == 512)
        {
            fwrite(buff, 1, 512, fout);
            blocks++;
            if(blocks % 21 == 0)
            {
                sprintf(cBuff,"%d blocks read",blocks);
                Label3->Caption = cBuff;
                //Label3->Repaint();
                Application->ProcessMessages();
            }
        }

        fclose(fout);
        CloseHandle(hDevice);
        free(buff);

        sprintf(cBuff,"%d blocks read",blocks);
        Label3->Caption = cBuff;
        Label3->Repaint();
        Application->ProcessMessages();

        MessageBox(NULL,"done","image",MB_OK);
        Label3->Caption = "";
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cbDriveChange(TObject *Sender)
{
    cbDrive->Text = cbDrive->Text.UpperCase();

    if(strlen(cbDrive->Text.c_str()) > 1)
        cbDrive->Text = cbDrive->Text.Delete(2,1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveDialog1SelectionChange(TObject *Sender)
{
    lbFileName->Caption = SaveDialog1->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btGeometryClick(TObject *Sender)
{
 char cDriveName[20];
 char cBuff[100];
 AnsiString aString;
 HANDLE hDevice;
 DISK_GEOMETRY dg;
 DWORD junk;
 ULONGLONG DiskSize;

    Memo1->Lines->Clear();
    strcpy(cDriveName,cbDrive->Text.c_str());
    strcat(cDriveName,":");
    if(QueryDosDevice(cDriveName,cBuff, 100) > 0)
        Memo1->Lines->Add(cBuff);

    aString = cBuff;
    strcpy(cDriveName,"\\\\.\\PHYSICALDRIVE");
    strcpy(cBuff, aString.SubString(aString.AnsiPos("Harddisk")+8,1).c_str());
    if( cBuff[0] < '0' || cBuff[0] > '9')
    {
        MessageBox(NULL,"Query did not return expected dive number","ERROR",MB_OK);
        return;
    }
    strcat(cDriveName,cBuff);
    Memo1->Lines->Add(cDriveName);

	hDevice = CreateFile(cDriveName,  // drive to open
						0,                // no access to the drive
						FILE_SHARE_READ | FILE_SHARE_WRITE, // share mode
						NULL,             // default security attributes
						OPEN_EXISTING,    // disposition
						0,                // file attributes
						NULL);            // do not copy file attributes

	if (hDevice == INVALID_HANDLE_VALUE) // cannot open the drive
	{
		MessageBox(NULL,"MMC drive open error","ERROR",MB_OK);
		return;
	}

	if( !DeviceIoControl(hDevice,				// device to be queried
						IOCTL_DISK_GET_DRIVE_GEOMETRY,  // operation to perform
						NULL, 0,				// no input buffer
						&dg, sizeof(dg),     // output buffer
						&junk,                 // # bytes returned
						(LPOVERLAPPED) NULL))  // synchronous I/O
	{
		MessageBox(NULL,"IOCTL_DISK_GET_DRIVE_GEOMETRY failed","ERROR",MB_OK);
        CloseHandle(hDevice);
		return;
	}
    else
    {
        sprintf(cBuff,"Cylinders = %I64d", dg.Cylinders);
        Memo1->Lines->Add(cBuff);
        sprintf(cBuff,"Tracks per cylinder = %ld", (ULONG) dg.TracksPerCylinder);
        Memo1->Lines->Add(cBuff);
        sprintf(cBuff,"Sectors per track = %ld", (ULONG) dg.SectorsPerTrack);
        Memo1->Lines->Add(cBuff);
        sprintf(cBuff,"Bytes per sector = %ld", (ULONG) dg.BytesPerSector);
        Memo1->Lines->Add(cBuff);
        DiskSize = (dg.Cylinders.QuadPart + 1) * (ULONG)dg.TracksPerCylinder *
        (ULONG)dg.SectorsPerTrack * (ULONG)dg.BytesPerSector;
        sprintf(cBuff,"Disk size = %I64d (Bytes) = %I64d (Kb)", DiskSize, DiskSize / 1024);
        Memo1->Lines->Add(cBuff);
	    if(dg.MediaType == RemovableMedia)
		    sprintf(cBuff,"Media typ is RemovableMedia");
	    if(dg.MediaType == FixedMedia)
		    sprintf(cBuff,"Media typ is FixedMedia");
        Memo1->Lines->Add(cBuff);
    }
    CloseHandle(hDevice);

}
//---------------------------------------------------------------------------


